com.holonplatform.core.property

## Interface TemporalProperty<T>

- Type Parameters:
    `T` - Property type
  All Superinterfaces:
    CloneableProperty<T,PathProperty<T>,PathProperty.Builder<T,PathProperty<T>,?>>, CloneableProperty.CloneablePathProperty<T,PathProperty<T>>, ConverterExpression<T>, DataMappable, Expression, HasConfiguration<PropertyConfiguration>, Localizable, Path<T>, PathExpression<T>, PathProperty<T>, Property<T>, QueryExpression<T>, QueryProjection<T>, Serializable, TemporalQueryExpression<T>, TypedExpression<T>, Validator.Validatable<T>
  All Known Subinterfaces:
    TemporalBeanProperty<T>, TemporalProperty.TemporalPropertyBuilder<T>

      public interface TemporalProperty<T>
      extends PathProperty<T>, TemporalQueryExpression<T>

  A temporal type `PathProperty`.

  Extends `TemporalQueryExpression` to provide temporal type related query expression builder methods.

  Since:
    5.1.0

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static interface` | `TemporalProperty.TemporalPropertyBuilder<T>` `TemporalProperty` builder.

    - ### Nested classes/interfaces inherited from interface com.holonplatform.core.property.PathProperty

      `PathProperty.Builder<T,P extends Path<T> & Property<T>,B extends PathProperty.Builder<T,P,B>>, PathProperty.PathPropertyBuilder<T>`

    - ### Nested classes/interfaces inherited from interface com.holonplatform.core.property.CloneableProperty

      `CloneableProperty.CloneablePathProperty<T,P extends Property<T> & Path<T>>`

    - ### Nested classes/interfaces inherited from interface com.holonplatform.core.property.Property

      `Property.PropertyAccessException, Property.PropertyNotFoundException, Property.PropertyReadException, Property.PropertyReadOnlyException, Property.PropertyWriteException`

    - ### Nested classes/interfaces inherited from interface com.holonplatform.core.i18n.Localizable

      `Localizable.LocalizableBuilder, Localizable.LocalizationException`

    - ### Nested classes/interfaces inherited from interface com.holonplatform.core.Expression

      `Expression.ExpressionResolverFunction<E extends Expression,R extends Expression>, Expression.InvalidExpressionException`

    - ### Nested classes/interfaces inherited from interface com.holonplatform.core.Path

      `Path.FinalPath<T>, Path.PathBuilder<T>`

  - ### Field Summary

    - ### Fields inherited from interface com.holonplatform.core.Path

      `PATH_HIERARCHY_SEPARATOR`

    - ### Fields inherited from interface com.holonplatform.core.DataMappable

      `DEFAULT_CONFIG_PROPERTY_PREFIX, PATH`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `TemporalProperty<T>` | `clone(Consumer<PathProperty.Builder<T,PathProperty<T>,?>> builder)` Clone this property.
    `static <T> TemporalProperty.TemporalPropertyBuilder<T>` | `create(Path<T> path)` Create a new `TemporalProperty` from given `path`, using given `Path` `name`and `type`.
    `static <T> TemporalProperty.TemporalPropertyBuilder<T>` | `create(String name, Class<? extends T> type)` Create a new `TemporalProperty` with given `name` and `type`.
    `static TemporalProperty.TemporalPropertyBuilder<Date>` | `date(String name)` Create a new `Date` type `TemporalProperty`.
    `static TemporalProperty.TemporalPropertyBuilder<LocalDate>` | `localDate(String name)` Create a new `LocalDate` type `TemporalProperty`.
    `static TemporalProperty.TemporalPropertyBuilder<LocalDateTime>` | `localDateTime(String name)` Create a new `localDateTime` type `TemporalProperty`.
    `static TemporalProperty.TemporalPropertyBuilder<LocalTime>` | `localTime(String name)` Create a new `LocalTime` type `TemporalProperty`.
    `static TemporalProperty.TemporalPropertyBuilder<OffsetDateTime>` | `offsetDateTime(String name)` Create a new `OffsetDateTime` type `TemporalProperty`.

    - ### Methods inherited from interface com.holonplatform.core.property.PathProperty

      `isReadOnly`

    - ### Methods inherited from interface com.holonplatform.core.property.Property

      `getConfiguration, getConvertedValue, getConverter, getExpressionValueConverter, getName, getTemporalType, getType, present, render, renderIfAvailable`

    - ### Methods inherited from interface com.holonplatform.core.Validator.Validatable

      `getValidators, validate`

    - ### Methods inherited from interface com.holonplatform.core.i18n.Localizable

      `builder, getMessage, getMessageArguments, getMessageCode, of, of`

    - ### Methods inherited from interface com.holonplatform.core.HasConfiguration

      `hasConfiguration`

    - ### Methods inherited from interface com.holonplatform.core.ConverterExpression

      `getModelType, getModelValue`

    - ### Methods inherited from interface com.holonplatform.core.TypedExpression

      `isCollectionExpression, isConverterExpression`

    - ### Methods inherited from interface com.holonplatform.core.Expression

      `validate`

    - ### Methods inherited from interface com.holonplatform.core.query.PathExpression

      `asc, desc, from`

    - ### Methods inherited from interface com.holonplatform.core.Path

      `fullName, fullName, getName, getParent, isRootPath, of, relativeName, relativeName, stream`

    - ### Methods inherited from interface com.holonplatform.core.DataMappable

      `getDataPath, isDataMappable`

    - ### Methods inherited from interface com.holonplatform.core.query.QueryExpression

      `between, count, eq, eq, goe, goe, gt, gt, in, in, in, isNotNull, isNull, loe, loe, lt, lt, max, min, neq, neq, nin, nin, nin`

    - ### Methods inherited from interface com.holonplatform.core.query.QueryProjection

      `bean, constant, countAll, path, propertySet, propertySet`

    - ### Methods inherited from interface com.holonplatform.core.query.TemporalQueryExpression

      `day, hour, month, year`

- - ### Method Detail

    - #### clone

          TemporalProperty<T> clone(Consumer<PathProperty.Builder<T,PathProperty<T>,?>> builder)

      Clone this property.
      Specified by:
        `clone` in interface `CloneableProperty<T,PathProperty<T>,PathProperty.Builder<T,PathProperty<T>,?>>`
      Parameters:
        `builder` - A property builder which can be used to perform additional property configuration
      Returns:
        The cloned property

    - #### create

          static <T> TemporalProperty.TemporalPropertyBuilder<T> create(String name,
                                                                        Class<? extends T> type)

      Create a new `TemporalProperty` with given `name` and `type`.
      Specified by:
        `create` in interface `PathExpression<T>`
      Specified by:
        `create` in interface `PathProperty<T>`
      Type Parameters:
        `T` - Property (path) type
      Parameters:
        `name` - Property name (not null)
        `type` - Property value type (not null)
      Returns:
        `TemporalProperty` builder

    - #### create

          static <T> TemporalProperty.TemporalPropertyBuilder<T> create(Path<T> path)

      Create a new `TemporalProperty` from given `path`, using given `Path` `name`and `type`.
      Specified by:
        `create` in interface `PathProperty<T>`
      Type Parameters:
        `T` - Path type
      Parameters:
        `path` - Path from which to obtain the property path name and type (not null)
      Returns:
        `TemporalProperty` builder

    - #### date

          static TemporalProperty.TemporalPropertyBuilder<Date> date(String name)

      Create a new `Date` type `TemporalProperty`.
      Parameters:
        `name` - Property name (not null)
      Returns:
        `TemporalProperty` builder

    - #### localDate

          static TemporalProperty.TemporalPropertyBuilder<LocalDate> localDate(String name)

      Create a new `LocalDate` type `TemporalProperty`.
      Parameters:
        `name` - Property name (not null)
      Returns:
        `TemporalProperty` builder

    - #### localDateTime

          static TemporalProperty.TemporalPropertyBuilder<LocalDateTime> localDateTime(String name)

      Create a new `localDateTime` type `TemporalProperty`.
      Parameters:
        `name` - Property name (not null)
      Returns:
        `TemporalProperty` builder

    - #### localTime

          static TemporalProperty.TemporalPropertyBuilder<LocalTime> localTime(String name)

      Create a new `LocalTime` type `TemporalProperty`.
      Parameters:
        `name` - Property name (not null)
      Returns:
        `TemporalProperty` builder

    - #### offsetDateTime

          static TemporalProperty.TemporalPropertyBuilder<OffsetDateTime> offsetDateTime(String name)

      Create a new `OffsetDateTime` type `TemporalProperty`.
      Parameters:
        `name` - Property name (not null)
      Returns:
        `TemporalProperty` builder

Copyright © 2019 The Holon Platform. All rights reserved.